/*
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef DSMLIB_DSMCALLBACKI_H
#define DSMLIB_DSMCALLBACKI_H

#include "DSMC.h"

namespace dsmlib
{
	/**A base class for user-supplied callback handlers.
	 * DSMC provides intermediate results via a callback.
	 * @see DSMC
	 */
	class DSMCallbackI
	{
	public:	

		/**A virtual destructor.
		 */
		virtual ~DSMCallbackI() {};
		
		/**The handler method.
		 * The implementation class must override this method.
		 * @param rResults A reference to a dsm results structure
		 */
		virtual void handle( const DSMC::ResultsC & rResults ) = 0;
				
	}; // class DSMCallbackI
	
}; // namespace dsmlib

#endif //DSMLIB_DSMCALLBACKI_H
