/*
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef IMAGELIB_ANALYZEIMAGELOADERI_H
#define IMAGELIB_ANALYZEIMAGELOADERI_H

#include "ImageLoaderI.h"
#include <string>

struct dsr;

namespace imagelib
{	
	/**Loader for Analyze (tm) 7.5 images.
	 */
	class AnalyzeImageLoaderC : virtual public ImageLoaderI
	{
	public:
		static AnalyzeImageLoaderC & getInstance();
		virtual ~AnalyzeImageLoaderC() throw();
		virtual const std::string & getDescription() const throw();		
		virtual bool accepts( const std::string & rFileName ) const throw();
		virtual ImageI * load( const std::string & rFileName, const ImageI::ParametersC & rParams ) const
			throw( iolib::ExceptionC );
		virtual void save( const ImageI * pProduct, const std::string & rFileName, const ImageI::ParametersC & rParams ) const
			throw( iolib::ExceptionC );
		virtual bool accepts( const std::string & rFileName, const ImageI::ParametersC & rParams ) const throw();
		virtual ImageI * load( const std::string & rFileName ) const
			throw( iolib::ExceptionC );
		virtual void save( const ImageI * pProduct, const std::string & rFileName ) const
			throw( iolib::ExceptionC );
	protected:
		static ImageI::ParametersC loadHeader( std::istream & rStream );
		AnalyzeImageLoaderC() throw();
	};
};

#endif //IMAGELIB_ANALYZEIMAGELOADERI_H
