/*
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "ImageC.h"

#include <meshlib/typedefs.h>

using namespace imagelib;
using namespace blitz;
using namespace meshlib;

void ImageC::normalize() throw ()
{
	TinyVector<int,3> dim( getDimensions() );
	MLFloat max = (*m_pImageData)(0,0,0);
	MLFloat min = max;
	for(int k = 0; k<dim(2); ++k)
	for(int j = 0; j<dim(1); ++j)
	for(int i = 0; i<dim(0); ++i)
	{
		if( (*m_pImageData)(i,j,k) > max )
			max = (*m_pImageData)(i,j,k);
		if( (*m_pImageData)(i,j,k) < min )
			min = (*m_pImageData)(i,j,k);
	}
	
	MLFloat divisor = max - min;
	for(int k = 0; k<dim(2); ++k)
	for(int j = 0; j<dim(1); ++j)
	for(int i = 0; i<dim(0); ++i)
	{
		(*m_pImageData)(i,j,k) = 
			((*m_pImageData)(i,j,k) - min ) / divisor;
	}
}

