/*
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef IOLIB_IOEXCEPTIONC_H
#define IOLIB_IOEXCEPTIONC_H

#include "ExceptionC.h"

namespace iolib
{
	/**Thrown when (disk) io fails.
	 * Permission denied etc...
	 */
	class IOExceptionC : public ExceptionC
	{
	public:

		/**See @see ExceptionC.
		 */
	    IOExceptionC() throw() {};
	    
		/**See @see ExceptionC.
		 */
	    IOExceptionC( const std::string & rWhat ) throw()
	    	: iolib::ExceptionC( rWhat ) {};
	    	
		/**See @see ExceptionC.
		 */
		IOExceptionC( const IOExceptionC & rException ) throw()
			: iolib::ExceptionC( rException ) {};
			
		/**See @see ExceptionC.
		 */
	    IOExceptionC& operator=( const IOExceptionC & rException ) throw()
	    {
	    	iolib::ExceptionC::operator=( rException );
	    	return *this;
	    };
	    
	    ///A virtual destructor.
	    virtual ~IOExceptionC() throw() {};
	    
	};
};

#endif // IOLIB_IOEXCEPTIONC_H
