/*
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef MESHLIB_OFFMESHLOADERC_H
#define MESHLIB_OFFMESHLOADERC_H

#include "MeshLoaderI.h"

namespace meshlib
{
	/**OFF mesh loader.
	 */
	class OFFMeshLoaderC : virtual public MeshLoaderI
	{
	public:

		static const OFFMeshLoaderC & getInstance();

		virtual ~OFFMeshLoaderC() throw();

		virtual const std::string & getDescription() const throw();		

		virtual bool accepts( const std::string & rFileName ) const throw();

		virtual bool accepts(
			const std::string & rFileName,
			const MeshC::ParametersC & rParams ) const throw();
			
		virtual MeshC * load( const std::string & rFileName ) const
			throw( iolib::ExceptionC );
			
		virtual MeshC * load(
			const std::string & rFileName,
			const MeshC::ParametersC & rParams ) const
			throw( iolib::ExceptionC );
			
		virtual void save(
			const MeshC * pProduct,
			const std::string & rFileName,
			const MeshC::ParametersC & rParams ) const
			throw( iolib::ExceptionC );
			
		virtual void save(
			const MeshC * pProduct,
			const std::string & rFileName ) const throw( iolib::ExceptionC );
			
	protected:

		/**A protected constructor.
		 * getInstance should be used to construct an OFFMeshLoaderC
		 * object.
		 */
		OFFMeshLoaderC() throw ();
		
	}; // class OFFMeshLoaderC

}; // namespace meshlib

#endif //PETLIB_OFFMESHLOADERC_H
