/*
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef PARAMLIB_PARAMETEREXCEPTIONC_H
#define PARAMLIB_PARAMETEREXCEPTIONC_H

#include <iolib/ExceptionC.h>

namespace paramlib
{
	/**An exception class.
	 * Thrown by ParametersC when parameter parsing fails.
	 */
	class ParameterExceptionC : public iolib::ExceptionC
	{
	public:

		/**Default constructor.
		 */
	    ParameterExceptionC() throw() {};

		/**Constructor with a string.
		 */
	    ParameterExceptionC( const std::string & rWhat ) throw()
	    	: iolib::ExceptionC(rWhat) {};
	    	
	    /**Copy constructor.
	     */
		ParameterExceptionC( const ParameterExceptionC & rX ) throw()
			: iolib::ExceptionC(rX) {};
		
		/**Assignment.
		 */
	    ParameterExceptionC& operator=( const ParameterExceptionC & rX ) throw()
	    	{ iolib::ExceptionC::operator=(rX); return *this; };

		/**A virtual destructor.
		 */
	    virtual ~ParameterExceptionC() throw() {};
	    
	}; // class ParameterExceptionC
	
}; // namespace paramlib

#endif // PARAMLIB_PARAMETEREXCEPTIONC_H
